package eswtshowcase.modules;

import org.eclipse.ercp.swt.mobile.Command;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
//import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

/**
 *
 */
public class CommandDemoModule implements DemoModule, SelectionListener{
    private Shell demoShell;
    private Composite demoComposite;
    
    private Command backCommand;
    
    private Command firstCommand;
    private Command secondCommand;
    private Command commandGroup;
    private Command firstGroupCommand;
    private Command secondGroupCommand;
    private Command thirdGroupCommand;
    private Command thirdCommand;
    
    public String getTitle(){
        return "Commands";
    }
    
    public String getDescription(){
        return "Demonstrates Commands";
    }
    
    public void runDemo(Shell parent){
        demoShell = new Shell(SWT.MAX);
        demoShell.setText("Commands");
        demoShell.setLayout(new FillLayout(SWT.VERTICAL));
        
        demoComposite = new Composite(demoShell, SWT.NONE);
        demoComposite.setLayout(new FillLayout(SWT.VERTICAL));
        demoShell.layout();

        //Create a Back command and add this as a selection listener
        //to get notified when the user uses the back button
        backCommand = new Command(demoShell, Command.EXIT, 0);
        backCommand.setText("Back");
        backCommand.addSelectionListener(this);
        
        firstCommand = new Command(demoShell, Command.SELECT, 1);
        firstCommand.setText("First");
        firstCommand.addSelectionListener(this);
        
        secondCommand = new Command(demoShell, Command.SELECT, 1);
        secondCommand.setText("Second");
        secondCommand.addSelectionListener(this);
        
        //Command groups are created by specifying the command type parameter
        //Command.COMMANDGROUP
        commandGroup = new Command(demoShell, Command.COMMANDGROUP, 1);
        commandGroup.setText("Group");
        commandGroup.addSelectionListener(this);
        
        //Adding commands to the command group works by setting the parent
        //of the command as the command group command. This works only if
        //the parent's type is Command.COMMANDGROUP
        firstGroupCommand = new Command(commandGroup, Command.SELECT, 2);
        firstGroupCommand.setText("First");
        firstGroupCommand.addSelectionListener(this);
        
        secondGroupCommand = new Command(commandGroup, Command.SELECT, 2);
        secondGroupCommand.setText("Second");
        secondGroupCommand.addSelectionListener(this);
        
        thirdGroupCommand = new Command(commandGroup, Command.SELECT, 2);
        thirdGroupCommand.setText("Third");
        thirdGroupCommand.addSelectionListener(this);
        
        thirdCommand = new Command(demoShell, Command.SELECT, 1);
        thirdCommand.setText("Third");
        thirdCommand.addSelectionListener(this);
        
        demoComposite.layout();
        demoShell.open();
        demoShell.setActive();
    }
    
    public void widgetSelected(SelectionEvent e){
        //here we can test whether it's command x that's selected
        if(e.widget.equals(backCommand)){
            back();
        } else if(e.widget.equals(firstCommand)){
            //add command handling code here
        } else if(e.widget.equals(secondCommand)){
            
        } else if(e.widget.equals(firstGroupCommand)){
            
        } else if(e.widget.equals(secondGroupCommand)){
            
        } else if(e.widget.equals(thirdGroupCommand)){
            
        } else if(e.widget.equals(thirdCommand)){
            
        }
    }
    
    public void widgetDefaultSelected(SelectionEvent e){
        //this doesn't get called for commands
    }
    
    private void back(){
        demoShell.dispose();
        demoShell = null;
    }
}
